import { ICache } from './ICache';
export declare class Cache<TKey, TValue> implements ICache<TKey, TValue> {
    private _cache;
    private static logger;
    private enabled;
    protected loggingEnable: boolean;
    constructor(_cache: ICache<TKey, TValue>);
    /**
     * @override
     */
    setCachedValue(key: TKey, value: TValue): void;
    /**
     * @override
     */
    getCachedValue(key: TKey): TValue;
    /**
     * @override
     */
    clear(): void;
    /**
     * @override
     */
    size(): number;
    /**
     * @override
     */
    setEnableLogging(enabled: boolean): void;
    /**
     * @override
     */
    isLoggingEnabled(): boolean;
    /**
     * @override
     */
    setEnable(enabled: boolean): void;
}
