"use strict";
var CacheTypeEnum_1 = require('../CacheTypeEnum');
var MemoryGlobalCache_1 = require('../memory/MemoryGlobalCache');
var NgZoneGlobalCache_1 = require('../zone/NgZoneGlobalCache');
/**
 * Zone cache provider
 */
var ZoneCacheProvider = (function () {
    function ZoneCacheProvider() {
    }
    /**
     * @override
     */
    ZoneCacheProvider.prototype.provideCache = function () {
        return NgZoneGlobalCache_1.NgZoneGlobalCache.INSTANCE;
    };
    ZoneCacheProvider.INSTANCE = new ZoneCacheProvider();
    return ZoneCacheProvider;
}());
/**
 * Memory cache provider
 */
var MemoryCacheProvider = (function () {
    function MemoryCacheProvider() {
    }
    /**
     * @override
     */
    MemoryCacheProvider.prototype.provideCache = function () {
        return MemoryGlobalCache_1.MemoryGlobalCache.INSTANCE;
    };
    MemoryCacheProvider.INSTANCE = new MemoryCacheProvider();
    return MemoryCacheProvider;
}());
function getProviderByType(cacheType) {
    switch (cacheType) {
        case CacheTypeEnum_1.CacheTypeEnum.ZONE:
            return ZoneCacheProvider.INSTANCE;
        case CacheTypeEnum_1.CacheTypeEnum.MEMORY:
            return MemoryCacheProvider.INSTANCE;
    }
    return null;
}
exports.getProviderByType = getProviderByType;
//# sourceMappingURL=provider.js.map