"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var core_1 = require('@angular/core');
var angular2_smart_logger_1 = require('angular2-smart-logger');
var MemoryCache_1 = require('../memory/MemoryCache');
var NgZoneGlobalCache = (function (_super) {
    __extends(NgZoneGlobalCache, _super);
    function NgZoneGlobalCache(ngZone) {
        var _this = this;
        _super.call(this);
        /**
         * The onUnstable & onStable are synchronized emitters, so we can use them.
         *
         * Consider the example:
         *
         *  setTimeout(() => {
         *      console.log('Zone 1');
         *      setTimeout(() => {
         *          console.log('Zone 2');
         *          setTimeout(() => {
         *              console.log('Zone 3');
         *          }, 10000);
         *      }, 10000);
         *  }, 10000);
         *
         * In the console we'll see:
         *
         *  [$NgZoneGlobalCache][onUnstable.subscribe] Initialize the cache context zone
         *  Zone 1
         *  [$NgZoneGlobalCache][setCachedValue]..
         *  ...
         *  [$NgZoneGlobalCache][onStable.subscribe] Destruction the cache context zone. The cache with size 14 will be cleared
         *  [$NgZoneGlobalCache][onUnstable.subscribe] Initialize the cache context zone
         *  Zone 2
         *  [$NgZoneGlobalCache][setCachedValue]..
         *  ...
         */
        /**
         * Notifies when code enters Angular Zone. This gets fired first on VM Turn.
         */
        ngZone.onUnstable.subscribe(function () {
            if (_this.isLoggingEnabled()) {
                NgZoneGlobalCache.zoneLogger.debug("[$NgZoneGlobalCache][onUnstable.subscribe] Initialize the cache context zone");
            }
            _this.clear();
        });
        /**
         * Notifies when the last `onMicrotaskEmpty` has run and there are no more microtasks, which
         * implies we are about to relinquish VM turn.
         * This event gets called just once.
         */
        ngZone.onStable.subscribe(function () {
            if (_this.isLoggingEnabled()) {
                NgZoneGlobalCache.zoneLogger.debug("[$NgZoneGlobalCache][onStable.subscribe] Destruction the cache context zone. The cache with size " + _this.size() + " will be cleared");
            }
            _this.clear();
        });
        NgZoneGlobalCache.INSTANCE = this;
    }
    NgZoneGlobalCache.zoneLogger = angular2_smart_logger_1.LoggerFactory.makeLogger(NgZoneGlobalCache);
    NgZoneGlobalCache = __decorate([
        core_1.Injectable(),
        __param(0, core_1.Inject(core_1.NgZone)), 
        __metadata('design:paramtypes', [core_1.NgZone])
    ], NgZoneGlobalCache);
    return NgZoneGlobalCache;
}(MemoryCache_1.MemoryCache));
exports.NgZoneGlobalCache = NgZoneGlobalCache;
//# sourceMappingURL=NgZoneGlobalCache.js.map